import win32.windows;
import win32.windef;
import win32.commctrl;
import win32frame.WindowObject;
import std.stdio;
import std.string;
import std.utf;

ushort LOWORD(uint l){ return l & 0xffff; }
ushort HIWORD(uint l){ return l >>> 16; }
COLORREF RGB(uint r, uint g, uint b) {
  return cast(COLORREF)(r | (g << 8) | (b << 16));
}

class MyButton : WindowObject {
  int      state ;
  HFONT    labelfont ;

  this(string name) {
    winc.style          = 0; //CS_HREDRAW | CS_VREDRAW ;
    this.setStyle(WS_CHILD | WS_TABSTOP | WS_CLIPSIBLINGS | WS_CLIPCHILDREN | WS_VISIBLE) ;
    winc.cbClsExtra     = 0;
    winc.cbWndExtra     = 0;
    winc.lpszMenuName   = null;
    winc.hCursor        = LoadCursor(null , cast(wchar*)(IDC_ARROW));
    winc.lpszClassName  = cast(wchar*)("MyButton") ;
    super(name) ;
    this.registwinc() ;
  }
  
  override int setFont(HFONT hfont){
    this.labelfont=hfont ;
    return(0) ;
  }

  LRESULT proc(HWND hwnd , UINT msg , WPARAM wp , LPARAM lp){
    switch (msg) {
    case WM_DESTROY:
      break ;
      
    case WM_CREATE :
      break ;
      
    case WM_PAINT:
      HDC hdc;
      PAINTSTRUCT ps ;
      HBRUSH COLBASE ;
      HPEN   COLHILIGHT, COLDKSHADE ;
      HPEN   COLLIGHT  , COLSHADE   ;
      
      COLBASE = CreateSolidBrush(GetSysColor(COLOR_3DFACE)) ;
      COLHILIGHT= CreatePen(PS_SOLID, 1, GetSysColor(COLOR_3DHILIGHT )) ;
      COLDKSHADE= CreatePen(PS_SOLID, 1, GetSysColor(COLOR_3DDKSHADOW)) ;
      COLLIGHT  = CreatePen(PS_SOLID, 1, GetSysColor(COLOR_3DLIGHT ))   ;
      COLSHADE  = CreatePen(PS_SOLID, 1, GetSysColor(COLOR_3DSHADOW))   ;
      
      hdc = BeginPaint(hwnd, &ps);
      SelectObject(hdc, COLBASE) ;
      Rectangle(hdc, 0,0,winW,winH) ;
      if( state==0 ){
	SelectObject(hdc, COLHILIGHT) ;
	MoveToEx(hdc,      1, winH-2, null) ;
	LineTo(  hdc,      1,      1) ;
	LineTo(  hdc, winW-2,      1) ;
	SelectObject(hdc, COLLIGHT) ;
	MoveToEx(hdc,      2, winH-3, null) ;
	LineTo(  hdc,      2,      2) ;
	LineTo(  hdc, winW-3,      2) ;
	SelectObject(hdc, COLDKSHADE) ;
	MoveToEx(hdc,      2, winH-2, null) ;
	LineTo(  hdc, winW-2, winH-2) ;
	LineTo(  hdc, winW-2,      1) ;
	SelectObject(hdc, COLSHADE) ;
	MoveToEx(hdc,      3, winH-3, null) ;
	LineTo(  hdc, winW-3, winH-3) ;
	LineTo(  hdc, winW-3,      2) ;
      }else{
	SelectObject(hdc, COLDKSHADE) ;
	MoveToEx(hdc,      1, winH-2, null) ;
	LineTo(  hdc,      1,      1) ;
	LineTo(  hdc, winW-1,      1) ;
	SelectObject(hdc, COLSHADE) ;
	MoveToEx(hdc,      2, winH-3, null) ;
	LineTo(  hdc,      2,      2) ;
	LineTo(  hdc, winW-2,      2) ;
	SelectObject(hdc, COLHILIGHT) ;
	MoveToEx(hdc,      2, winH-2, null) ;
	LineTo(  hdc, winW-2, winH-2) ;
	LineTo(  hdc, winW-2,      1) ;
	SelectObject(hdc, COLLIGHT) ;
	MoveToEx(hdc,      3, winH-3, null) ;
	LineTo(  hdc, winW-3, winH-3) ;
	LineTo(  hdc, winW-3,      2) ;
      }

      SetBkMode(hdc , TRANSPARENT);
      {
	SIZE labelsize ;
	wchar[] label=(toUTF16(this.name)).dup ;

	GetTextExtentPoint32(hdc , cast(wchar*)(label) , label.length , &labelsize);
	SelectObject(hdc,labelfont) ;
	TextOut(hdc,
		(winW-labelsize.cx)/2,
		(winH-labelsize.cy)/2,
		cast(wchar*)(label), label.length) ;
      }
      
      EndPaint(hwnd, &ps);
      
      DeleteObject(COLBASE ) ;
      DeleteObject(COLHILIGHT) ;
      DeleteObject(COLDKSHADE) ;
      break ;

    case WM_SIZE:
      winW=LOWORD(lp) ;
      winH=HIWORD(lp) ;
      RedrawWindow( hwnd, null, null, RDW_INVALIDATE) ;
      break;

    case WM_LBUTTONDOWN:
      state=1 ;
      SetCapture( hwnd ) ;
      InvalidateRect(hwnd , null , true);
      SetFocus(hwnd) ;
      break ;
      
    case WM_LBUTTONUP:
      state=0 ;
      InvalidateRect(hwnd , null , true);
      sendmsgtoparent( WM_COMMAND, cast(int)(this.hmenu), 0) ;
      ReleaseCapture() ;
      break ;
      
    default :
      return( DefWindowProc(hwnd , msg , wp , lp) );
    }
    return(0);
  }

}
